/*
   Copyright (C) 2002 Dylan Yudaken(d_yud@hotmail.com)

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License
   as published by the Free Software Foundation; either version 2
   of the License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

   See gpl.txt for more information regarding the GNU General Public License.
*/
//REALLY Badly done menu code//
//Going to write a proper UI sometime but not 
//neccesary for such simple game menu.
//Would be nice if done properly

#include "common.h"
#define MENUITEMS 11
extern CGame *Game;
void CMenu::Draw()
{
	int ow = 640;//Ortho ow and oh(Cant change yet)
	int oh = 480;
	char buff[64];
	checkKeys();
	glDisable(GL_DEPTH_TEST);							// Disables Depth Testing
	glMatrixMode(GL_PROJECTION);						// Select The Projection Matrix
	glPushMatrix();										// Store The Projection Matrix
	glLoadIdentity();									// Reset The Projection Matrix
	glOrtho(0,ow,0,oh,-100,100);							// Set Up An Ortho Screen
	glMatrixMode(GL_MODELVIEW);							// Select The Modelview Matrix
	glPushMatrix();										// Store The Modelview Matrix
	glLoadIdentity();									// Reset The Modelview Matrix
	
	glColor3f(1 ,1,1);
	FontText.BindTexture();
	glEnable(GL_TEXTURE_2D);
	DrawQuad2d(215,470,224,480,&MenuTex);				//nice background
	//DrawCube(220,368,0,224,224,0);
	glColor3f(1,0,0);									//set base color
	if(Selected == 0)									//If selected change colour
		glColor3f(0,1,0);
	sprintf(buff,"New Game");							//Send to buff new string
	glSPrint(1,640,480,(ow/2)-(strlen(buff)*13)/2,oh/2+(32*3),1,buff);//Print it
	glColor3f(1,0,0);
	if(Selected == 1)
		glColor3f(0,1,0);	
	sprintf(buff,"Width %d",OptionWidth);
	glSPrint(1,640,480,(ow/2)-(strlen(buff)*13)/2,oh/2+(32*2),1,buff);
	glColor3f(1,0,0);
	if(Selected == 2)
		glColor3f(0,1,0);
	sprintf(buff,"Height %d",OptionHeight);
	glSPrint(1,640,480,(ow/2)-(strlen(buff)*13)/2,oh/2+(32*1),1,buff);
	glColor3f(1,0,0);
	if(Selected == 3)
		glColor3f(0,1,0);
	sprintf(buff,"Depth %d",OptionDepth);
	glSPrint(1,640,480,(ow/2)-(strlen(buff)*13)/2,oh/2,1,buff);
	glColor3f(1,0,0);
	if(Selected == 4)
		glColor3f(0,1,0);
	sprintf(buff,"Level %d",OptionLevel);
	glSPrint(1,640,480,(ow/2)-(strlen(buff)*13)/2,oh/2-(32*1),1,buff);
	glColor3f(1,0,0);	
	if(Selected == 5)
		glColor3f(0,1,0);
	switch(OptionSet){
	case SET_FLAT:
		sprintf(buff,"Set  Flat");
		break;
	case SET_SIMPLE:
		sprintf(buff,"Set  Simple");
		break;
	case SET_COMPLEX:
		sprintf(buff,"Set  Complex");
		break;
	default:
		sprintf(buff,"Set   Error");
		break;
	};
	glSPrint(1,640,480,(ow/2)-(strlen(buff)*13)/2,oh/2-(32*2),1,buff);
	glColor3f(1,0,0);
	if(Selected == 6)
		glColor3f(0,1,0);
	sprintf(buff,"Sound %s",(Game->SoundOpt ? "ON" : "OFF"));
	glSPrint(1,640,480,(ow/2)-(strlen(buff)*13)/2,oh/2-(32*3),1,buff);
	glColor3f(1,0,0);
	if(Selected == 7)
		glColor3f(0,1,0);
	sprintf(buff,"Help Block %s",(Game->GhostBlock ? "ON" : "OFF"));
	glSPrint(1,640,480,(ow/2)-(strlen(buff)*13)/2,oh/2-(32*4),1,buff);
	glColor3f(1,0,0);
	if(Selected == 8)
		glColor3f(0,1,0);
	sprintf(buff,"High Scores");
	glSPrint(1,640,480,(ow/2)-(strlen(buff)*13)/2,oh/2-(32*5),1,buff);
	glColor3f(1,0,0);
	if(Selected == 9)
		glColor3f(0,1,0);
	sprintf(buff,"Help");
	glSPrint(1,640,480,(ow/2)-(strlen(buff)*13)/2,oh/2-(32*6),1,buff);
	glColor3f(1,0,0);
	if(Selected == 10)
		glColor3f(0,1,0);
	sprintf(buff,"Quit");
	glSPrint(1,640,480,(ow/2)-(strlen(buff)*13)/2,oh/2-(32*7),1,buff);
	glMatrixMode(GL_PROJECTION);						// Select The Projection Matrix
	glPopMatrix();										// Restore The Old Projection Matrix
	glMatrixMode(GL_MODELVIEW);							// Select The Modelview Matrix
	glPopMatrix();										// Restore The Old Projection Matrix
	glEnable(GL_DEPTH_TEST);							// Enables Depth Testing
		
}

//Check Menu keys//
void CMenu::checkKeys(){
	if(keys[SDLK_RETURN]&& !keyc[SDLK_RETURN]){
		keyc[SDLK_RETURN] = true;
		switch(Selected){
		case 0:
			RestartGame(OptionWidth,OptionHeight,OptionDepth,OptionLevel,OptionSet);
			Gamestate = GAME_MAIN;
			break;
		case 8:
			Gamestate = HIGHSCORES;
			break;
		case 9:
			Gamestate = GAME_HELP;
			break;
		case 10:
			SaveLastSettings("settings.dat");
			done = true;
			break;
		default:
			break;
		};
	}
	if(keyc[SDLK_RETURN] && !(keys[SDLK_RETURN])){
		keyc[SDLK_RETURN] = false;
	}

	if(keys[SDLK_UP] && !keyc[SDLK_UP]){
		keyc[SDLK_UP] = true;
		Selected--;
		if(Selected <0)
			Selected = 0;

	}
	if(keyc[SDLK_UP] && !(keys[SDLK_UP])){
		keyc[SDLK_UP] = false;
	}

	if(keys[SDLK_DOWN]&& !keyc[SDLK_DOWN]){
		keyc[SDLK_DOWN] = true;
		Selected++;
		if(Selected >= MENUITEMS)
			Selected = MENUITEMS-1;
	}
	if(keyc[SDLK_DOWN] && !(keys[SDLK_DOWN])){
		keyc[SDLK_DOWN] = false;
	}
	
	if(keys[SDLK_LEFT]&& !keyc[SDLK_LEFT]){
		keyc[SDLK_LEFT] = true;
		switch(Selected){
		case 1:
			OptionWidth -= 1;
			if(OptionWidth < OptionWidthMin)
				OptionWidth = OptionWidthMin;
			break;
		case 2:
			OptionHeight -= 1;
			if(OptionHeight < OptionHeightMin)
				OptionHeight = OptionHeightMin;
			break;
		case 3:
			OptionDepth -= 1;
			if(OptionDepth < OptionDepthMin)
				OptionDepth = OptionDepthMin;
			break;
		case 4:
			OptionLevel -= 1;
			if(OptionLevel < OptionLevelMin)
				OptionLevel = OptionLevelMin;
			break;
		case 5:
			OptionSet -= 1;
			if(OptionSet < OptionSetMin)
				OptionSet = OptionSetMin;
			break;
		case 6:
			Game->SoundOpt = 0;
			break;
		case 7:
			Game->GhostBlock= 0;
			break;
		default:
			break;
		};
	}
	if(keyc[SDLK_LEFT] && !(keys[SDLK_LEFT])){
		keyc[SDLK_LEFT] = false;
	}
	
	if(keys[SDLK_RIGHT]&& !keyc[SDLK_RIGHT]){
		keyc[SDLK_RIGHT] = true;
		switch(Selected){
		case 1:
			OptionWidth += 1;
			if(OptionWidth > OptionWidthMax)
				OptionWidth = OptionWidthMax;
			break;
		case 2:
			OptionHeight += 1;
			if(OptionHeight > OptionHeightMax)
				OptionHeight = OptionHeightMax;
			break;
		case 3:
			OptionDepth += 1;
			if(OptionDepth > OptionDepthMax)
				OptionDepth = OptionDepthMax;
			break;
		case 4:
			OptionLevel += 1;
			if(OptionLevel > OptionLevelMax)
				OptionLevel = OptionLevelMax;
			break;
		case 5:
			OptionSet += 1;
			if(OptionSet > OptionSetMax)
				OptionSet = OptionSetMax;
			break;
		case 6:
			Game->SoundOpt = 1;
			break;			
		case 7:
			Game->GhostBlock= 1;
			break;	
		default:
			break;
		};
	}
	if(keyc[SDLK_RIGHT] && !(keys[SDLK_RIGHT])){
		keyc[SDLK_RIGHT] = false;
	}
	if(keys[SDLK_ESCAPE]&& !keyc[SDLK_ESCAPE]){
		keyc[SDLK_ESCAPE] = true;
		if(Game->Active)
			Gamestate = GAME_MAIN;
	}
	if(keyc[SDLK_ESCAPE] && !(keys[SDLK_ESCAPE])){
		keyc[SDLK_ESCAPE] = false;
	}	

}
void CMenu::init()
{
	OptionHeightMin = HEIGHTMIN;
	OptionHeightMax = HEIGHTMAX;
	OptionHeight = 4;
	
	OptionWidthMin = WIDTHMIN;
	OptionWidthMax = WIDTHMAX;
	OptionWidth = 4;

	OptionDepthMin = DEPTHMIN;
	OptionDepthMax = DEPTHMAX;
	OptionDepth = 11;

	OptionLevelMin = 0;  //Min values
	OptionLevelMax = LEVELMAX;	//Maximum values
	OptionLevel = 3;			//real values
	OptionSetMax = 3;
	OptionSetMin = 1;
	OptionSet = 1;
	Game->SoundOpt = 1;
	Game->GhostBlock = 1;
	LoadLastSettings("settings.dat");
	
}
void CMenu::LoadLastSettings(char *f)
{
	char buffer[64];
	sprintf(buffer,"%s%s",DataDir,f);
	FILE *file = fopen(buffer,"r");
	
	fgets(buffer,64,file);//Option oh
	OptionHeight = atoi(buffer);
	fgets(buffer,64,file);//Option ow
	OptionWidth = atoi(buffer);
	fgets(buffer,64,file);//Option Depth
	OptionDepth = atoi(buffer);
	fgets(buffer,64,file);//Option Level
	OptionLevel = atoi(buffer);
	fgets(buffer,64,file);//Option Set
	OptionSet = atoi(buffer);
	fgets(buffer,64,file);//Sound Option
	Game->SoundOpt = atoi(buffer);
	fgets(buffer,64,file);//Ghost block Option
	Game->GhostBlock = atoi(buffer);
	fclose(file);
}
void CMenu::SaveLastSettings(char *f)
{
	char buffer[64];
	sprintf(buffer,"%s%s",DataDir,f);
	FILE *file = fopen(buffer,"w");

	fprintf(file,"%d\n",OptionHeight);
	fprintf(file,"%d\n",OptionWidth);
	fprintf(file,"%d\n",OptionDepth);
	fprintf(file,"%d\n",OptionLevel);
	fprintf(file,"%d\n",OptionSet);
	fprintf(file,"%d\n",Game->SoundOpt);
	fprintf(file,"%d\n",Game->GhostBlock);
	fclose(file);
}