/*
   Copyright (C) 2002 Dylan Yudaken(d_yud@hotmail.com)

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License
   as published by the Free Software Foundation; either version 2
   of the License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

   See gpl.txt for more information regarding the GNU General Public License.
*/

#ifndef _H_CGL_
#define _H_CGL_


class CGl{
public:
    SDL_VideoInfo *videoInfo;//Our video info
	SDL_Surface *surface;	//actual surface 
	int videoFlags;
	GLvoid ReSizeGLScene(GLsizei width, GLsizei height);
	int InitGL(GLvoid);
	GLvoid KillGLWindow(GLvoid);
	int CreateGLWindow(char* title, int width, int height, int bits, bool fullscreenflag);
};
void DrawQuad(GLfloat x,GLfloat y,GLfloat w,GLfloat h,CIndivTexture *Text); // Quad
void DrawQuad2d(GLint x,GLint y,GLint w,GLint h,CIndivTexture *Text); //2d Quad(ints)
void DrawCube(GLfloat x,GLfloat y,GLfloat z,GLfloat w,GLfloat h,GLfloat v); //Cube 
extern CGl GL;
extern int Width;
extern int Height;


#endif