/*
   Copyright (C) 2002 Dylan Yudaken(d_yud@hotmail.com)

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License
   as published by the Free Software Foundation; either version 2
   of the License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

   See gpl.txt for more information regarding the GNU General Public License.
*/
 #ifndef _C_SOUND_H_DEF
#define _C_SOUND_H_DEF
class CSound{
public:
	int Init();
	void Stop();
	~CSound()
	{
		Stop();
	}
};
extern CSound Sound;
class CIndivSound{
public:
	Mix_Chunk *wave;
	int chan;
	int Load(char * file);
	int Play();
	void Destroy();
	~CIndivSound()
	{
		Destroy();
	}
};
class CIndivMusic{
public:
	Mix_Music *music;
	int Load(char * file);
	int Play();
	void Destroy();
	~CIndivMusic()
	{
		Destroy();
	}
};
#endif

