/*
   Copyright (C) 2002 Dylan Yudaken(d_yud@hotmail.com)

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License
   as published by the Free Software Foundation; either version 2
   of the License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

   See gpl.txt for more information regarding the GNU General Public License.
*/
#ifndef TEXTURE_H_DEF
#define TEXTURE_H_DEF

class CTexture{
public:
	CTexture();
	~CTexture();
	GLuint TextureList[MAX_TEXTURES];
	int UsedTextures[MAX_TEXTURES];
};
class CIndivTexture{
public:
	~CIndivTexture();
	GLuint	filter;		// Which Filter To Use
	GLuint	TexID;
	char* TextureFilename;
	int LoadGLTexture(char *file);// Load Bitmaps And Convert To Textures
	void BindTexture(void);
};
SDL_Surface *Flip(SDL_Surface *src);	//Used to flip a texture
SDL_Surface *MakeRGB(SDL_Surface *src);	//Convert it to RGB
Uint32 getpixel(SDL_Surface *surface, int x, int y);
void putpixel(SDL_Surface *surface, int x, int y, Uint32 pixel);
#endif